package anywheresoftware.b4a.samples.scrollview;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.scrollview", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.scrollview", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.collections.List _bitmaps = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scrollview1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndown = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnup = null;
public anywheresoftware.b4a.objects.collections.List _files = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
anywheresoftware.b4a.objects.drawable.BitmapDrawable _bd = null;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 12;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(2048);
 BA.debugLineNum = 13;BA.debugLine="If FirstTime Then 'only load the images once.";
Debug.ShouldStop(4096);
if (_firsttime) { 
 BA.debugLineNum = 14;BA.debugLine="ProgressDialogShow(\"Loading images\")";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Loading images");
 BA.debugLineNum = 15;BA.debugLine="LoadImages";
Debug.ShouldStop(16384);
_loadimages();
 BA.debugLineNum = 16;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 };
 BA.debugLineNum = 19;BA.debugLine="Activity.LoadLayout(\"1\") 'load the layout file";
Debug.ShouldStop(262144);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 20;BA.debugLine="ScrollView1.Panel.Height = 200dip * Bitmaps.Size 'Set the inner panel height according to the number of images.";
Debug.ShouldStop(524288);
mostCurrent._scrollview1.getPanel().setHeight((int)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200))*_bitmaps.getSize()));
 BA.debugLineNum = 21;BA.debugLine="For i = 0 To Bitmaps.Size - 1";
Debug.ShouldStop(1048576);
{
final double step17 = 1;
final double limit17 = (int)(_bitmaps.getSize()-1);
for (_i = (int)(0); (step17 > 0 && _i <= limit17) || (step17 < 0 && _i >= limit17); _i += step17) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 22;BA.debugLine="Dim iv As ImageView 'create an ImageView for each bitmap";
Debug.ShouldStop(2097152);
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();Debug.locals.put("iv", _iv);
 BA.debugLineNum = 23;BA.debugLine="iv.Initialize(\"\") 'not interested in any events so we pass empty string.";
Debug.ShouldStop(4194304);
_iv.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 24;BA.debugLine="Dim bd As BitmapDrawable";
Debug.ShouldStop(8388608);
_bd = new anywheresoftware.b4a.objects.drawable.BitmapDrawable();Debug.locals.put("bd", _bd);
 BA.debugLineNum = 25;BA.debugLine="bd.Initialize(Bitmaps.Get(i))";
Debug.ShouldStop(16777216);
_bd.Initialize((android.graphics.Bitmap)(_bitmaps.Get(_i)));
 BA.debugLineNum = 26;BA.debugLine="iv.Background = bd 'set the background of the image view.";
Debug.ShouldStop(33554432);
_iv.setBackground((android.graphics.drawable.Drawable)(_bd.getObject()));
 BA.debugLineNum = 28;BA.debugLine="ScrollView1.Panel.AddView(iv, 5dip, 5dip + i * 200dip, ScrollView1.Width - 10dip, 190dip)";
Debug.ShouldStop(134217728);
mostCurrent._scrollview1.getPanel().AddView((android.view.View)(_iv.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5)),(int)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5))+_i*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200))),(int)(mostCurrent._scrollview1.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(190)));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 31;BA.debugLine="btnUp.Tag = -200dip";
Debug.ShouldStop(1073741824);
mostCurrent._btnup.setTag((Object)(-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200))));
 BA.debugLineNum = 32;BA.debugLine="btnDown.Tag = 200dip";
Debug.ShouldStop(-2147483648);
mostCurrent._btndown.setTag((Object)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200))));
 BA.debugLineNum = 33;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 80;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(32768);
 BA.debugLineNum = 82;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 76;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(2048);
 BA.debugLineNum = 78;BA.debugLine="End Sub";
Debug.ShouldStop(8192);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btn_click() throws Exception{
		Debug.PushSubsStack("btn_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.ConcreteViewWrapper _v = null;
 BA.debugLineNum = 70;BA.debugLine="Sub btn_Click";
Debug.ShouldStop(32);
 BA.debugLineNum = 71;BA.debugLine="Dim v As View";
Debug.ShouldStop(64);
_v = new anywheresoftware.b4a.objects.ConcreteViewWrapper();Debug.locals.put("v", _v);
 BA.debugLineNum = 72;BA.debugLine="v = Sender 'this way we can handle both buttons from the same sub.";
Debug.ShouldStop(128);
_v.setObject((android.view.View)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 73;BA.debugLine="ScrollView1.ScrollPosition = ScrollView1.ScrollPosition + v.Tag 'v.tag will be -200 or 200.";
Debug.ShouldStop(256);
mostCurrent._scrollview1.setScrollPosition((int)(mostCurrent._scrollview1.getScrollPosition()+(double)(BA.ObjectToNumber(_v.getTag()))));
 BA.debugLineNum = 74;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                if (mostCurrent != null) {
Debug.StartDebugging(mostCurrent.activityBA, 11977, new int[] {3} );}

		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 5;BA.debugLine="Sub Globals";
 BA.debugLineNum = 6;BA.debugLine="Dim ScrollView1 As ScrollView";
mostCurrent._scrollview1 = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 BA.debugLineNum = 7;BA.debugLine="Dim btnDown As Button";
mostCurrent._btndown = new anywheresoftware.b4a.objects.ButtonWrapper();
 BA.debugLineNum = 8;BA.debugLine="Dim btnUp As Button";
mostCurrent._btnup = new anywheresoftware.b4a.objects.ButtonWrapper();
 BA.debugLineNum = 9;BA.debugLine="Dim files As List";
mostCurrent._files = new anywheresoftware.b4a.objects.collections.List();
 BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
public static String  _loadimages() throws Exception{
		Debug.PushSubsStack("LoadImages (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String _imagesfolder = "";
int _i = 0;
String _f = "";
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _b = null;
 BA.debugLineNum = 34;BA.debugLine="Sub LoadImages";
Debug.ShouldStop(2);
 BA.debugLineNum = 35;BA.debugLine="Bitmaps.Initialize";
Debug.ShouldStop(4);
_bitmaps.Initialize();
 BA.debugLineNum = 36;BA.debugLine="Dim files As List ' MODIFICADA por Juan A.";
Debug.ShouldStop(8);
mostCurrent._files = new anywheresoftware.b4a.objects.collections.List();
 BA.debugLineNum = 37;BA.debugLine="files.Initialize() ' MODIFICADA por Juan A.";
Debug.ShouldStop(16);
mostCurrent._files.Initialize();
 BA.debugLineNum = 41;BA.debugLine="imagesFolder = File.DirAssets ' MODIFICADA por Juan A.";
Debug.ShouldStop(256);
_imagesfolder = anywheresoftware.b4a.keywords.Common.File.getDirAssets();Debug.locals.put("imagesfolder", _imagesfolder);
 BA.debugLineNum = 54;BA.debugLine="files = File.ListFiles(imagesFolder) 'get all files in this folder";
Debug.ShouldStop(2097152);
mostCurrent._files = anywheresoftware.b4a.keywords.Common.File.ListFiles(_imagesfolder);
 BA.debugLineNum = 57;BA.debugLine="For i = 0 To files.Size - 1";
Debug.ShouldStop(16777216);
{
final double step34 = 1;
final double limit34 = (int)(mostCurrent._files.getSize()-1);
for (_i = (int)(0); (step34 > 0 && _i <= limit34) || (step34 < 0 && _i >= limit34); _i += step34) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 58;BA.debugLine="DoEvents 'required for the ProgressDialog animation";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.DoEvents();
 BA.debugLineNum = 59;BA.debugLine="Dim f As String";
Debug.ShouldStop(67108864);
_f = "";Debug.locals.put("f", _f);
 BA.debugLineNum = 60;BA.debugLine="f = files.Get(i)";
Debug.ShouldStop(134217728);
_f = String.valueOf(mostCurrent._files.Get(_i));Debug.locals.put("f", _f);
 BA.debugLineNum = 61;BA.debugLine="If f.ToLowerCase.EndsWith(\".jpg\") Then";
Debug.ShouldStop(268435456);
if (_f.toLowerCase().endsWith(".jpg")) { 
 BA.debugLineNum = 62;BA.debugLine="Dim b As Bitmap";
Debug.ShouldStop(536870912);
_b = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();Debug.locals.put("b", _b);
 BA.debugLineNum = 63;BA.debugLine="b.InitializeSample(imagesFolder, f, 200dip, 200dip) 'load the jpeg file and subsample it if it is too large.";
Debug.ShouldStop(1073741824);
_b.InitializeSample(_imagesfolder,_f,anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200)));
 BA.debugLineNum = 64;BA.debugLine="Bitmaps.Add(b) 'add the bitmap to the bitmaps list.";
Debug.ShouldStop(-2147483648);
_bitmaps.Add((Object)(_b.getObject()));
 BA.debugLineNum = 65;BA.debugLine="If Bitmaps.Size > 50 Then Exit 'limit it to 50 images";
Debug.ShouldStop(1);
if (_bitmaps.getSize()>(int)(50)) { 
if (true) break;};
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 68;BA.debugLine="ToastMessageShow(\"Found \" & Bitmaps.Size & \" images\", True)";
Debug.ShouldStop(8);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Found "+BA.NumberToString(_bitmaps.getSize())+" images",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 69;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 2;BA.debugLine="Dim Bitmaps As List";
_bitmaps = new anywheresoftware.b4a.objects.collections.List();
 BA.debugLineNum = 3;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"Bitmaps",_bitmaps,"ScrollView1",_scrollview1,"btnDown",_btndown,"btnUp",_btnup,"files",_files};
}
}
